Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('core-js/modules/es.array.for-each');
require('core-js/modules/es.array.is-array');
require('core-js/modules/es.array.iterator');
require('core-js/modules/es.object.to-string');
require('core-js/modules/es.promise');
require('core-js/modules/es.set');
require('core-js/modules/es.string.iterator');
require('core-js/modules/web.dom-collections.for-each');
require('core-js/modules/web.dom-collections.iterator');
require('regenerator-runtime/runtime');
var dom = require('@testing-library/dom');
var Twig = _interopDefault(require('twig'));
var fs = _interopDefault(require('fs'));
var DrupalAttribute = _interopDefault(require('drupal-attribute'));

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

var mountedContainers = new Set();

if (typeof afterEach === "function") {
  afterEach(cleanup);
}

function render(_x) {
  return _render.apply(this, arguments);
}

function _render() {
  _render = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(twigFile) {
    var context,
        namespaces,
        twigCallback,
        baseElement,
        container,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            context = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : {};
            namespaces = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : {};
            twigCallback = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : function () {};
            baseElement = document.body;
            container = baseElement.appendChild(document.createElement("div")); // Add it to the mounted containers to cleanup.

            mountedContainers.add(container);
            twigCallback(Twig);
            _context2.next = 9;
            return loadTemplate(twigFile, context, namespaces);

          case 9:
            container.innerHTML = _context2.sent;
            return _context2.abrupt("return", _objectSpread2({
              container: container,
              baseElement: baseElement,
              debug: function debug() {
                var el = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : baseElement;
                var maxLength = arguments.length > 1 ? arguments[1] : undefined;
                var options = arguments.length > 2 ? arguments[2] : undefined;
                return Array.isArray(el) ? // eslint-disable-next-line no-console
                el.forEach(function (e) {
                  return console.log(dom.prettyDOM(e, maxLength, options));
                }) : // eslint-disable-next-line no-console,
                console.log(dom.prettyDOM(el, maxLength, options));
              }
            }, dom.getQueriesForElement(baseElement)));

          case 11:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _render.apply(this, arguments);
}

var loadTemplate = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(file) {
    var context,
        namespaces,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
            namespaces = _args.length > 2 ? _args[2] : undefined;

            Twig.registryReset = function () {
              Twig.Templates.registry = {};
            };

            Twig.cache(false);
            Twig.extendFunction("create_attribute", function (value) {
              return new DrupalAttribute(value);
            });

            Twig.twigAsync = function (options) {
              return new Promise(function (resolve, reject) {
                options.load = resolve;
                options.error = reject;
                options.async = true;
                options.autoescape = false;
                options.namespaces = namespaces;

                if (options.data || options.ref) {
                  try {
                    resolve(Twig.twig(options));
                  } catch (error) {
                    reject(error);
                  }
                } else {
                  fs.readFile(options.path, "utf8", function (err, data) {
                    if (err) {
                      reject(new Error("Unable to find template file ".concat(options.path)));
                      return;
                    }

                    options.load = function (template) {
                      template.rawMarkup = data;
                      resolve(template);
                    };

                    Twig.twig(options);
                  });
                }
              });
            };

            return _context.abrupt("return", Twig.twigAsync({
              path: file
            }).then(function (template) {
              context.attributes = new DrupalAttribute();
              return template.render(context);
            }));

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function loadTemplate(_x2) {
    return _ref.apply(this, arguments);
  };
}();

function cleanup() {
  mountedContainers.forEach(cleanupContainer);
}

function cleanupContainer(container) {
  if (container.parentNode === document.body) {
    document.body.removeChild(container);
  }

  mountedContainers["delete"](container);
} // just re-export everything from dom-testing-library
/* eslint func-name-matching:0 */

Object.keys(dom).forEach(function (k) {
  if (k !== 'default') Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () {
      return dom[k];
    }
  });
});
exports.Twig = Twig;
exports.cleanup = cleanup;
exports.render = render;
